/*
 * This file is part of the ToolBox.
 * Copyright Thomas Jacob.
 *
 * READ README.TXT BEFORE USE!!
 */


#ifndef __TOOLBOX_HASHSET_INL
#define __TOOLBOX_HASHSET_INL


// --- Class HashSet ---

inline void HashSet::Add(void * key)
{
	HashMap<Void>::Set(key, NULL);
}

inline bool HashSet::Contains(void * key) const
{
	return HashMap<Void>::ContainsKey(key);
}

inline PointeredList * HashSet::GetAll() const
{
	return HashMap<Void>::GetKeys();
}

inline long HashSet::GetCount() const
{
	return HashMap<Void>::GetCount();
}

inline bool HashSet::IsEmpty() const
{
	return HashMap<Void>::IsEmpty();
}

inline void HashSet::Remove(void * key)
{
	HashMap<Void>::Unset(key);
}

inline void HashSet::RemoveAll()
{
	HashMap<Void>::UnsetAll();
}


// --- Class IntKeyHashSet ---

inline void IntKeyHashSet::Add(long key)
{
	IntKeyHashMap<Void>::Set(key, NULL);
}

inline bool IntKeyHashSet::Contains(long key) const
{
	return IntKeyHashMap<Void>::ContainsKey(key);
}

inline PointeredList * IntKeyHashSet::GetAll() const
{
	return IntKeyHashMap<Void>::GetKeys();
}

inline void IntKeyHashSet::Remove(long key)
{
	IntKeyHashMap<Void>::Unset(key);
}

inline void IntKeyHashSet::RemoveAll()
{
	IntKeyHashMap<Void>::UnsetAll();
}


// --- Class StringKeyHashSet ---

inline void StringKeyHashSet::Add(const char * key)
{
	StringKeyHashMap<Void>::Set(key, NULL);
}

inline bool StringKeyHashSet::Contains(const char * key) const
{
	return StringKeyHashMap<Void>::ContainsKey(key);
}

inline PointeredList * StringKeyHashSet::GetAll() const
{
	return StringKeyHashMap<Void>::GetKeys();
}

inline void StringKeyHashSet::Remove(const char * key)
{
	StringKeyHashMap<Void>::Unset(key);
}

inline void StringKeyHashSet::RemoveAll()
{
	StringKeyHashMap<Void>::UnsetAll();
}


// --- Class ICStringKeyHashSet ---

inline void ICStringKeyHashSet::Add(const char * key)
{
	ICStringKeyHashMap<Void>::Set(key, NULL);
}

inline bool ICStringKeyHashSet::Contains(const char * key) const
{
	return ICStringKeyHashMap<Void>::ContainsKey(key);
}

inline PointeredList * ICStringKeyHashSet::GetAll() const
{
	return ICStringKeyHashMap<Void>::GetKeys();
}

inline void ICStringKeyHashSet::Remove(const char * key)
{
	ICStringKeyHashMap<Void>::Unset(key);
}

inline void ICStringKeyHashSet::RemoveAll()
{
	ICStringKeyHashMap<Void>::UnsetAll();
}


#endif
